#!/usr/bin/env tclsh
#
#    Copyright (C) 2006 Mark Oakden
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


proc handler {} {
    while { [gets stdin line] != -1 } {
	switch -glob $line {
	    trackChange { trackChange }
	    "engineStateChange: playing" { engineStateChange playing }
	    "engineStateChange: paused" { engineStateChange paused }
	    "engineStateChange: idle" { engineStateChange idle }
	    "engineStateChange: empty" { engineStateChange empty }
	}
    }
}

proc amarokCommand { args } {
    eval exec dcop amarok $args
}

proc emacsCommand { cmd } {
    catch {exec gnuclient -batch -eval $cmd} res
    return $res
}

proc trackChange {} {
    set track [amarokCommand player nowPlaying]
    set form "(ics-set-amarok-now-playing \"$track\")"
    set res [emacsCommand $form]
}

proc engineStateChange { state } {
    switch -glob $state {
	playing { if { [string equal $::lastState "paused"] } { trackChange } }
	empty { emacsCommand "(ics-set-amarok-now-playing \"Nothing (player is stopped)\")" }
	paused { emacsCommand "(ics-set-amarok-now-playing \"Nothing (player is paused)\")" }
	idle { emacsCommand "(ics-set-amarok-now-playing \"Nothing (player is idle)\")" }
    }
    set ::lastState $state
}

set ::lastState uninitialised
fileevent stdin readable handler
vwait forever
# That's all, folks.
